<?php

namespace App\DataFixtures;

use Doctrine\Bundle\FixturesBundle\Fixture;
use Doctrine\Common\Persistence\ObjectManager;
use League\Csv\Reader;
use App\Entity\ValeursFonciere;
use League\Csv\Statement;

class AppFixtures extends Fixture
{
    public function load(ObjectManager $manager)
    {

        $manager->getConnection()->getConfiguration()->setSQLLogger(null);

        $offset = 1;
        $recordsLimitByLoop = 100;

        $fileName_partLeft = 'valeursfoncieres-201';
        $fileName_partRight = '.txt';

        for($fileName_partMiddle=5; $fileName_partMiddle <= 9; $fileName_partMiddle++){

            $fileName = $fileName_partLeft . $fileName_partMiddle . $fileName_partRight;

            var_dump("started file " . $fileName);

            $csv = Reader::createFromPath('%kernel.root.dir%/../public/Donnees/'.$fileName);
            $csv->setDelimiter("|");
            $stmt = (new Statement())->offset($offset);
            $records = $stmt->process($csv);

            $numRecordsRead = 0;

            foreach ($records as $row) {

                $valeursFonciere = new ValeursFonciere();
                $valeursFonciere->setDateMutation(\DateTime::createFromFormat("d/m/Y", $row[8]));
                $valeursFonciere->setNatureMutation($row[9]);
                $valeursFonciere->setValeurFonciere(floatval(str_replace(',', '.', $row[10])));
                $valeursFonciere->setCommune($row[17]);
                $valeursFonciere->setCodeCommune(intval($row[19]));
                $valeursFonciere->setCodeTypeLocal(intval($row[35]));
                $valeursFonciere->setTypeLocal($row[36]);
                $valeursFonciere->setSurfaceReelleBati(floatval(str_replace(',', '.', $row[38])));
                $manager->persist($valeursFonciere);

                $numRecordsRead++;

                if(($numRecordsRead % $recordsLimitByLoop) == 0){
                    $manager->flush();
                    $manager->clear();
                }
            }

            $manager->flush();
            var_dump("Num of records " . $numRecordsRead);
        }
    }
}
